/* DACS-9600 JE^  2013/8/23 */
package jp.dacs_giken.dacsusbcounter;

import android.os.Bundle;
import android.app.Activity;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;
import android.view.WindowManager;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.BroadcastReceiver;
import android.widget.Button;
import android.view.View.OnClickListener;
import android.view.KeyEvent;
import android.view.View;
import android.os.Handler;
import java.util.Timer;
import java.util.TimerTask;
import java.io.*; 

import com.ftdi.j2xx.D2xxManager;
import com.ftdi.j2xx.FT_Device;

public class DacsUsbCounter extends Activity implements OnClickListener, OnEditorActionListener {  // main

    private TextView[] _cntView = new TextView[4];    // JE^\
    private Button _buttonEx;                         // {^
    private Button _buttonLk;                         // 샍bN؊{^
    private Button _buttonSS;                         // ݒۑ{^
    private Button _buttonSE;                         // ݒ{^
    private Button[] _buttonT = new Button[3];        // JEgJn/~{^
    private Button[] _buttonR = new Button[3];        // Zbg{^
    private Button[] _buttonE = new Button[3];        // JEg[h؊{^
    private Button[] _buttonLS = new Button[3];       // ŏIlݒ{^
    private Button _buttonHL;                         // z[h[h؊{^
    private Button[] _buttonLM = new Button[3];       // ŏIl~؊{^
    private TextView[] _lastView = new TextView[3];   // ŏIl\
    private EditText _editlastvalue;     // L[͕\
    
    D2xxManager ftD2xx;                // FTDI D2XX hCo
    FT_Device dacsDev = null;          // DACS foCX
    public static final int RBUF_SIZE  = 512;  // Mf[^ǎobt@TCY(byte)
    byte[] rbuf;                       // Mf[^ǎobt@(bytez)
    int recnum = 0;                    // Mf[^ǎoCg
    int recreq = 9;                    // Mf[^ǎvoCg
    int retrycnt = 0;                  // Ďs񐔃JEg
    
    public boolean bReadThreadGoing = false;   // ǎ菈
    public readThread read_thread;     // ǎ菈Xbh
    
    private Handler handler = new Handler();
    private Timer mytimer = new Timer();
    public static final int R_TIMEOVER  = 50;  // M^CAEgJE^Il
    
    String mtdata = "M08";             // JEglǎR}h

    int oper_lock = 0;                 // 샍bN  0:W@\  1:g@\ 2:s
    int cnt_HL_state = 0;              // z[h[hݒ  0:z[h  1:Q[gԊu  2:ށ[g
    int[] cnt_GT_state = {0,0,0};      // JEgJn/~   0:~  1:Jn
    int[] cnt_EN_state = {0,0,0};      // JEg[hݒ   0:UP/DOWN  1:GR[_
    int[] cnt_LM_state = {0,0,0};      // ŏIl~샂[hݒ   0:JԂ  1:ŏIŒ~
    int[] cntlast = {-1,-1,-1};        // JEgŏIlۑ
    int cntsetflag = 0;                // JE^ݒv
    int edittimmer = 0;                // L[͕\p^C}[
    
    /**** ʕ\̏ƃfoCXOPEN ****/

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().setSoftInputMode(WindowManager.LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN); // \tgL[{[hB
        setContentView(R.layout.activity_dacs_usb_counter);
        int i;
        _cntView[0] = (TextView)findViewById(R.id.textViewD0);      // JE^0
        _cntView[1] = (TextView)findViewById(R.id.textViewD1);      // JE^1
        _cntView[2] = (TextView)findViewById(R.id.textViewD2);      // JE^2
        _cntView[3] = (TextView)findViewById(R.id.textViewD3);      // JE^3(z[h)
        _lastView[0] = (TextView)findViewById(R.id.text_Lastvalue0); // ŏIl0\
        _lastView[1] = (TextView)findViewById(R.id.text_Lastvalue1); // ŏIl1\
        _lastView[2] = (TextView)findViewById(R.id.text_Lastvalue2); // ŏIl2\
        _buttonEx = (Button)this.findViewById(R.id.buttonEx);       // {^
        _buttonLk = (Button)this.findViewById(R.id.buttonLk);       // 샍bN{^
        _buttonSS = (Button)this.findViewById(R.id.buttonSS);       // ݒۑ{^
        _buttonSE = (Button)this.findViewById(R.id.buttonSE);       // ݒ{^
        _buttonT[0] = (Button)this.findViewById(R.id.buttonT0);     // JEgJn/~{^
        _buttonT[1] = (Button)this.findViewById(R.id.buttonT1);
        _buttonT[2] = (Button)this.findViewById(R.id.buttonT2);
        _buttonR[0] = (Button)this.findViewById(R.id.buttonR0);     // Zbg{^
        _buttonR[1] = (Button)this.findViewById(R.id.buttonR1);
        _buttonR[2] = (Button)this.findViewById(R.id.buttonR2);
        _buttonE[0] = (Button)this.findViewById(R.id.buttonE0);     // JEg[h؊{^
        _buttonE[1] = (Button)this.findViewById(R.id.buttonE1);
        _buttonE[2] = (Button)this.findViewById(R.id.buttonE2);
        _buttonLS[0] = (Button)this.findViewById(R.id.buttonLS0);   // ŏIlݒ{^
        _buttonLS[1] = (Button)this.findViewById(R.id.buttonLS1);
        _buttonLS[2] = (Button)this.findViewById(R.id.buttonLS2);
        _buttonLM[0] = (Button)this.findViewById(R.id.buttonLM0);   // ŏIl~؊{^
        _buttonLM[1] = (Button)this.findViewById(R.id.buttonLM1);
        _buttonLM[2] = (Button)this.findViewById(R.id.buttonLM2);
        _buttonHL = (Button)this.findViewById(R.id.buttonHL);       // z[h[h؊{^
        _buttonEx.setOnClickListener(this);                         // {^NbN̏
        _buttonLk.setOnClickListener(this);                         // 샍bN{^NbN̏
        _buttonSS.setOnClickListener(this);                         // ݒۑ{^NbN̏
        _buttonSE.setOnClickListener(this);                         // ݒ{^NbN̏
        _buttonHL.setOnClickListener(this);                         // z[h[h؊{^NbN̏
        for(i=0; i < 3; i++) _buttonT[i].setOnClickListener(this);  // JEgJn/~{^NbN̏
        for(i=0; i < 3; i++) _buttonR[i].setOnClickListener(this);  // Zbg{^NbN̏
        for(i=0; i < 3; i++) _buttonE[i].setOnClickListener(this);  // JEg[h؊{^NbN̏
        for(i=0; i < 3; i++) _buttonLS[i].setOnClickListener(this); // ŏIlݒ{^NbN̏
        for(i=0; i < 3; i++) _buttonLM[i].setOnClickListener(this); // ŏIl~؊{^NbN̏
        _editlastvalue = (EditText)findViewById(R.id.edit_Lastvalue);  // L[͕\
    	_editlastvalue.setOnEditorActionListener(this);

        dacsopen();                                                 // DACS USBfoCXopenƃJE^̏ݒ
        
        // obe\p
        IntentFilter filter = new IntentFilter();                   // CegtB^̓o^
        filter.addAction(Intent.ACTION_BATTERY_CHANGED);            // ACTION_BATTERY_CHANGEDANVǉ 
        registerReceiver(mBroadcastReceiver, filter);               // u[hLXgV[oo^
    }
    
    /**** Ȉ ****/

    @Override
    public void onDestroy() {
        super.onDestroy();
        mytimer.cancel();
        bReadThreadGoing = false;
        unregisterReceiver(mBroadcastReceiver);           // u[hLXgV[o菜 
        if(dacsDev != null){
            if(dacsDev.isOpen()) dacsDev.close();         // foCXclose
        }
        return;
    }

    /**** USBfoCXopenƃJE^ݒ ****/

    public void dacsopen(){
        int devCount = 0;                                 // foCXڑ (̃vO1݂̂ɑΉ)
        rbuf = new byte[RBUF_SIZE];                       // Mf[^ǎobt@
        try {
            ftD2xx = D2xxManager.getInstance(this);       // hCõCX^X쐬
            devCount = ftD2xx.createDeviceInfoList(this); // foCXXg擾
            if(devCount > 0) {                            // foCX1ȏ̂Ƃ
                dacsDev = ftD2xx.openByIndex(this, 0);    // foCXCfbNXɂOPEN
            }
            else {
                _cntView[0].setText("e@̐ڑȂ");       // foCXȂƂ̃bZ[W
                return;
            }
            if(dacsDev.isOpen()) {                        // foCXOPENłƂ
            	dacsDev.setBitMode((byte) 0x80, D2xxManager.FT_BITMODE_CBUS_BITBANG);
                                                          // W[dON DACS-9600p
                dacsDev.setBaudRate(38400);               // {[[gDACS-9600pƂĂ
                dacsDev.setChars((byte)0xd, (byte)1, (byte)0 ,(byte)0);  // CxgLN^ݒ
                dacsDev.purge((byte) (D2xxManager.FT_PURGE_TX | D2xxManager.FT_PURGE_RX));
                                                          // hCȏMobt@ɂ
                dacsDev.restartInTask();                  // hCo̎M^XNN
                _cntView[0].setText("e@ɐڑ");          // bZ[W\
                read_thread = new readThread();           // ǎ菈Xbh쐬
                read_thread.start();                      // ǎ菈XbhJn
                bReadThreadGoing = true;                  // ǎ菈-->쒆
                param_read();                             // **** ݒt@C̓ǎ
                cntsetflag = 1;                           // **** JE^̐ݒv(ݒۑt@Cݒ𕜌)
                mytimer.schedule(new MyTimer(), 500);     // JE^lǎ菈Np^C}[̃Zbg
            }       
            else {                                        // OPENłȂƂ
                _cntView[0].setText("OPENG[ 2");         // G[bZ[W\
            }
        }
        catch (D2xxManager.D2xxException ex) {            // G[
            if(dacsDev != null){
                if(dacsDev.isOpen()) dacsDev.close();     // foCXclose
            }
            _cntView[0].setText("OPENG[ 1");             // G[bZ[W\
        }
    }

    /**** DACS USBfoCX Đݒ ****/
    
    public void dacsRestart() {
    	bReadThreadGoing = false;
        if(dacsDev != null){
            if(dacsDev.isOpen()) dacsDev.close();   // foCXclose
        }
        dacsopen();                             // DACS USBfoCXopenƃJE^̏ݒ
    }
    
    /**** ݒt@C̓ǎ ****/

    public void param_read(){
        int i;
        String s;
        String[] stemp;
        try{
            InputStream in = openFileInput("DacsUsbCounter.par");    // DacsUsbCounter.par open
            BufferedReader reader = new BufferedReader(new InputStreamReader(in,"UTF-8"));
            s = reader.readLine();                        // 1sڂ̓ǎ  (샍bN, z[h[h)
            stemp = s.split(",", 0);
            oper_lock = Integer.parseInt(stemp[0]);       // 샍bNԃZbg
            cnt_HL_state = Integer.parseInt(stemp[1]);    // z[h[hZbg
            for(i = 0; i < 3; i++){
                s = reader.readLine();
                stemp = s.split(",", 0);
                cnt_GT_state[i] = Integer.parseInt(stemp[0]);  // JEgJn/~Zbg
                cnt_EN_state[i] = Integer.parseInt(stemp[1]);  // JEg[hZbg
                cnt_LM_state[i] = Integer.parseInt(stemp[2]);  // ŏIl~Zbg
                cntlast[i] = Integer.parseInt(stemp[3]);       // JEgŏIlZbg
            }
            reader.close();                               // DacsUsbCounter.par close
        } catch(IOException e){
            e.printStackTrace();
        }
        if(oper_lock == 0) _buttonLk.setText("W");  // 샍bNԂ\
        else{
            _buttonLk.setText("g");
        }
    }

    /**** ݒt@C̕ۑ ****/

    public void param_save(){
        deleteFile("DacsUsbCounter.par");                 // DacsUsbCounter.par 
        int i;
        String s;
        try{
            OutputStream out = openFileOutput("DacsUsbCounter.par",MODE_PRIVATE); // DacsUsbCounter.par open
            PrintWriter writer = new PrintWriter(new OutputStreamWriter(out,"UTF-8"));
            s = Integer.toString(oper_lock) + ","+Integer.toString(cnt_HL_state) + "\n";
            writer.append(s);                                     // 1sڂ̏  (샍bN, z[h[h)
            for(i = 0; i < 3; i++){
                s = Integer.toString(cnt_GT_state[i]) + ",";      // JEgJn/~
                s = s + Integer.toString(cnt_EN_state[i]) + ",";  // JEg[h
                s = s + Integer.toString(cnt_LM_state[i]) + ",";  // ŏIl~
                s = s + Integer.toString(cntlast[i]) + "\n";      // JEgŏIl
                writer.append(s);                                 // JE^1̃f[^Psɏ
            }
            writer.close();                                       // DacsUsbCounter.par close
        } catch(IOException e){
            e.printStackTrace();
        }
    }

    /**** {^NbNƂ̏ ****/

    public void onClick(View v){
        int i;
        if(v.getId() == R.id.buttonLk){         // **** 샍bN{^̂Ƃ ****
            if(oper_lock == 0){
                oper_lock = 1;                      // g@\Ƃ
                _buttonLk.setText("g");              
            }
            else{
                if(oper_lock == 1){
                    oper_lock = 2;                  // sƂ
                    _buttonLk.setText("s");
                    _buttonSS.setText("");
                    _buttonSE.setText("");
                    _buttonEx.setText("");
                }
                else{
                    oper_lock = 0;                  // W@\Ƃ
                    _buttonLk.setText("W");
                    _buttonSS.setText("ݒۑ");
                    _buttonSE.setText("ݒ");
                    _buttonEx.setText("");
                }
            }
            return;
        }
        if(oper_lock == 2) return;              // s̂Ƃ͈Ȍ̏𽷯
        if(v.getId() == R.id.buttonEx){         // **** {^̂Ƃ ****
            mytimer.cancel();                       // ^C}[LZ
            bReadThreadGoing = false;               // ǎ菈Ԃ~Ƃ
            if(dacsDev != null){
                if(dacsDev.isOpen()) dacsDev.close();  // foCXclose
            }
            this.finish();                          // vOI
            return;
        }
        if(v.getId() == R.id.buttonSS){         // **** ݒۑ{^̂Ƃ ****
            param_save();                           // ݒԂۑ
            return;
        }
        if(v.getId() == R.id.buttonSE){         // **** ݒ{^̂Ƃ ****
            deleteFile("DacsUsbCounter.par");       // DacsUsbCounter.par 
            return;
        }
        if((dacsDev == null) || (dacsDev.isOpen() == false)) return;
                                                // foCX̐ڑȂƂ͈Ȍ̏𽷯
        i = 10;                                 // {^ʗp
        switch(v.getId()){                      // **** vJn/~{^̂Ƃ ****
            case R.id.buttonT0: i = 0; break;
            case R.id.buttonT1: i = 1; break;
            case R.id.buttonT2: i = 2; break;
        }
        if(i < 3){
            cnt_GT_state[i] = cnt_GT_state[i] ^ 1;  // JEgJn/~ύX
            cntsetflag = 1;                         // JE^ݒv
            return;
        }
        switch(v.getId()){                      // **** JEg[h؊{^̂Ƃ ****
            case R.id.buttonE0: i = 0; break;
            case R.id.buttonE1: i = 1; break;
            case R.id.buttonE2: i = 2; break;
        }
        if(i < 3){
            if(i == 0) cnt_HL_state = 0;            // JEg0̂Ƃ́Az[h[hb`\ɂ
            cnt_EN_state[i] ++;                     // JEg[hύX
            if(cnt_EN_state[i] > 2) cnt_EN_state[i] = 0;
            cntsetflag = 1;                         // JE^ݒv
            return;
        }
        if(oper_lock == 1){                     // g@\̂Ƃ
            switch(v.getId()){                  // **** ŏIl~샂[h؊{^̂Ƃ ****
                case R.id.buttonLM0: i = 0; break;
                case R.id.buttonLM1: i = 1; break;
                case R.id.buttonLM2: i = 2; break;
            }
        }
        if(i < 3){
            if(i == 0) cnt_HL_state = 0;            // JE^0̂Ƃ́Az[h[hb`\ɂ
            cnt_LM_state[i] = cnt_LM_state[i] ^ 1;  // ŏIl~ύX
            cntsetflag = 1;                         // JE^ݒv
            return;
        }
        if(oper_lock == 1){                     // g@\̂Ƃ
            switch(v.getId()){                  // **** ŏIlݒ{^̂Ƃ ****
                case R.id.buttonLS0: i = 0; break;
                case R.id.buttonLS1: i = 1; break;
                case R.id.buttonLS2: i = 2; break;
            }
        }
        if(i < 3){
        	edittimmer = 0;                         // L[͕\^C}[Zbg
            String s = _editlastvalue.getText().toString();   // L[͕擾
            if(s.length() != 0){                    // L[͂Ƃ
                int j;
                try {
                    j = Integer.valueOf(s);         // ͕𐮐ɕϊ
                } catch(NumberFormatException e) {
                    _editlastvalue.setText("");     // L[͂
                	return;
                }
                cntlast[i] = j;                     // l̏ꍇA͒lۑ
                cntsetflag = 1;                     // JE^ݒv
                _editlastvalue.setText("");         // L[͂
            }
            else _editlastvalue.setText(Integer.toString(cntlast[i])); // L[͂Ɍ݂̍ŏIl\
            return;
        }
        if(v.getId() == R.id.buttonHL){         // **** z[h[h؊{^̂Ƃ ****
            cnt_EN_state[0] = 0;                    // JE^0̃JEg[hUP/DOWNJEg[hƂ
            cnt_LM_state[0] = 0;                    // JE^0JԂɂ
            cnt_HL_state ++;                        // z[h[hύX
            if(cnt_HL_state > 2) cnt_HL_state = 0;
            cntsetflag = 1;                         // JE^ݒv
            return;
        }
        switch(v.getId()){                      // **** Zbg{^̂Ƃ ****
            case R.id.buttonR0: i = 0; break;
            case R.id.buttonR1: i = 1; break;
            case R.id.buttonR2: i = 2; break;
        }
        String s;
        if(i < 3){
            s = "M0"+i*2+"1";                       // Zbgp M0x1 (M001,M021,M041) 
            dacsSenRec(s, 9);                       // R}hMƃX|XM
            return;
        }
    }

    /**** GO(enter)L[ƂR}hMƃX|XM ****/

    public boolean onEditorAction(TextView textview, int id, KeyEvent keyEvent) {

    	String s = _editlastvalue.getText().toString();  // L[͕擾
    	if((s.length() > 1) && (oper_lock == 1)){   // ͕2ȏ̂Ƃ͑Ms
    		int ir;
    		if(s.length() > 9) ir = 10;             // ʃR[h̎Mf[^
    		else               ir = 9;              // ʃR[hȂ̎Mf[^
    		int ec = dacsSenRec(s, ir);             // Ms
   	        String t = "";
   	        if(ec > R_TIMEOVER) t = "^CAEgG[";  // ^CAEĝƂG[bZ[W
   	        else{                                   // ɎMłƂ
	            for(int i=0; i<recnum-1; i++) t = t + (char)(rbuf[i]); // Mf[^𕶎ɕϊ
   	        }
   	        _editlastvalue.setText(t);              // Mf[^\(^CAEĝƂ̓G[bZ[W)
        	edittimmer = 1;                         // L[͕\^C}[X^[g
    	}
    	return true;
    }
    
    /**** JE^̐ݒ  ****/

    public int counter_setup(){
        int i, j, k;
        int ec = 0, mcode;
        String s, t;

        for(i = 0; i < 3; i++){                         // JE^3̌JԂ
        	
        	// **** ʃ[hpR}h̏ ****
            if(cnt_GT_state[i] == 1){                   // JEgJn/~
                _buttonT[i].setText("v"+i);           // vJnƂ
                s = "M0"+i*2+"8";                       // vJnp M0x8 
            }
            else{
            	_buttonT[i].setText("~"+i);         // v~Ƃ
                s = "M0"+i*2+"4";                       // v~p M0x4 
            }
            j = cntlast[i];                             // JEgŏIl
            if(j == -1) _lastView[i].setText(" ");      // |P̂Ƃ̓Xy[X\Ƃ
            else{
            	t = String.format("%,14d", j);          // 14ŒEl̕ɕϊ
            	_lastView[i].setText(t);                // ʕ\
            }
            s = s + String.format("%04x", (j & 0xffff)); // 32bit̉16bit𒊏oA16iɕϊ
            ec = dacsSenRec(s, 9);                      // ʃ[hpR}hMƃX|XM
            if(ec > R_TIMEOVER) break;

            // **** ʃ[hpR}h̏ ****
        	mcode = 0;                                  // MR}h4ڂA0Ƃ
            if(cnt_EN_state[i] == 1){
                _buttonE[i].setText("EN");              // GR[_[hƂ
                mcode = mcode + 8;                      // MR}h4 8ON
            }else _buttonE[i].setText("UD");            // UP/DOWNJEg[hɂ
            if(cnt_LM_state[i] == 1){
                _buttonLM[i].setText("ŏIŒ~");       // ŏIŒ~ɂ
                mcode = mcode + 1;                      // MR}h4 1ON
            }
            else _buttonLM[i].setText("JԂ");         // JԂɂ
            if(i == 0){                                 // JE^0̂Ƃ
                if(cnt_HL_state == 0) _buttonHL.setText("b`");  // b`[hƂ
                else{
                    if(cnt_HL_state == 1){
                        _buttonHL.setText("Q[gԊu");  // Q[gԊu(v)[hƂ
                        mcode = mcode + 4;              // MR}h4 4ON
                    }
                    else{
                        _buttonHL.setText("Q[g");    // Q[g(pXv)[hƂ
                        mcode = mcode + 6;              // MR}h4 42ON
                    }
                }
            }
            s = "M0" + (i*2+1) + Integer.toHexString(mcode);  // MpMR}h
            k = j/0x10000;
            if(j < 0) k--;
            s = s + String.format("%04x", (k & 0xffff)); // 32bit̏16bit𒊏oA16iɕϊ
            ec = dacsSenRec(s, 9);                       // ʃ[hpR}hMƃX|XM
            if(ec > R_TIMEOVER) break;
        }
        return ec;
    }

    /**** f[^MƎMf[^ǎ菈 ****/

    public int dacsSenRec(String s, int num) {
        if((dacsDev != null) && (dacsDev.isOpen())){  // foCXڑ̂Ƃ
            s = s + "\r";                          // ͕CRR[hǉ
            recnum = 0;                            // Mf[^ǎoCgZbg
            recreq = num;
            byte[] writeByte = s.getBytes();       // ͕𑗐MpoCgzɕϊ
            synchronized(dacsDev) {
                dacsDev.purge((byte) (D2xxManager.FT_PURGE_TX | D2xxManager.FT_PURGE_RX));
                                                   // Mobt@NA
                dacsDev.write(writeByte, s.length());  // Ms
            }
            int ec = 0;                            // M^CJE^
            do{
                try {
                    Thread.sleep(10);              // 10msX[v
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                ec++;
                if(ec > R_TIMEOVER) break;         // ^CAEĝƂ[vʂ
            }while(recnum < num);                  // Mf[^ɂȂ܂Ń[v
            return ec;                             // M^CJE^߂lƂ
        }
        else return R_TIMEOVER;
    }

    /**** JE^lǎ菈 (^C}[ɂJԂ) ****/

    private class MyTimer extends TimerTask {
        public void run() {
            handler.post(new Runnable(){
                public void run() {
                    if((dacsDev != null) && (dacsDev.isOpen())) {       // foCXڑ̂Ƃ
                        if(cntsetflag == 1){
                        	int ec = counter_setup();                   // JE^ݒ
                        	cntsetflag = 0;                             // JE^ݒv
                        	if(ec > R_TIMEOVER) dacsRestart();          // MG[̂ƂUSBfoCXĐݒ
                        	else mytimer.schedule(new MyTimer(), 50);   // ^C}[ċN
                            return;
                        }
                        int ec = dacsSenRec(mtdata, 37);                // ǎR}h(M08)̑MƃX|X̎M
                        int testnum = 0;
                        if((ec < R_TIMEOVER) && (rbuf[0] == 0x4e) && (rbuf[2] == 0x38)){
                        	                                            // M^CI[o[̂ƂA擪NłȂƂ͂͂ȂɂȂ
                            for(testnum = 0; testnum < 4; testnum++){   // 4JE^JԂ
                                int idata = 0;                          // MJEgl(16bit)Zbg
                                int rdata = 0;                          // Mf[^1oCg
                                int dpoint = testnum*8+4;               // JEgf[^̐擪ʒu
                                for(int i=0; i<8; i++ ){                // 8(16bit)̌JԂ
                                    rdata = (((int)rbuf[i+dpoint]) & 0xff) -0x30;   // 16i̕𐮐lɕϊ
                                    if(rdata > 9) rdata = rdata -7;
                                    idata = idata*16 + rdata;           // ̌̌vZ
                                }
                                String t = String.format("%,14d", idata);  // 14ŒEl̕ɕϊ
                                _cntView[testnum].setText(t);           // ʕ\
                            }
                            retrycnt = 0;                               // Ďs񐔂Zbg
                        }
                        else retrycnt++;                                // Ďs񐔂XV
                        if(retrycnt < 10) mytimer.schedule(new MyTimer(), 50);  // ^C}[ċN
                        else{
                        	dacsRestart();                              // MG[̂ƂUSBfoCXĐݒ
                            retrycnt = 0;                               // Ďs񐔂Zbg
                        }
                        
                        if(edittimmer != 0) edittimmer++;               // L[͕\p^C}[XV
                        if(edittimmer > 30){
                        	edittimmer = 0;
                        	_editlastvalue.setText("");                 // L[͕\                     	
                        }
                    }
                }
            });
        }
    }

    /**** Mf[^ǎXbh ****/

    private class readThread extends Thread {
        @Override
        public void run() {
            int inable = 0;                                             // hCoMĂoCg
            int icount = 0;
            while(bReadThreadGoing == true) {                           // ǎ菈Ԃ̂Ƃ
                try {
                    Thread.sleep(2);                                    // 2msX[v
                }
                catch (InterruptedException e) {
                    e.printStackTrace();
                }
                synchronized(dacsDev) {
                    inable = dacsDev.getQueueStatus();                  // MĂf[^mF
                    if(inable > RBUF_SIZE) inable = RBUF_SIZE;          // ǎoCg𐧌
                    if(inable > 0){
                        if((inable >= recreq) || (icount > 500)){
                        	recnum = dacsDev.read(rbuf, inable);        // ǎs
                        	icount = 0;
                        }
                        else icount++;
                    }
                    else icount = 0;    
                }
            }
        }
    }
    
    /**** obe\p  ****/
    
    private BroadcastReceiver mBroadcastReceiver = new BroadcastReceiver(){
    	
        public void onReceive(Context context, Intent intent){
    	    String action = intent.getAction();
    	    if(action.equals(Intent.ACTION_BATTERY_CHANGED)){           // ACTION_BATTERY_CHANGEDꍇ
    		    int level = intent.getIntExtra("level", 0);             // dr̎cʂ擾
    		    int voltage = intent.getIntExtra("voltage", 0);         // dr̓d擾
    		    String s =  "obec " + level + "%" + " d " + voltage + "mV";
    	        setTitle("DACS-9600 JE^    [ " + s + " ]");
    	    }
        }
    };
}
